unit plugin_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    DeleteCtrl: TButton;
    ListCtrls: TListBox;
    ButtonCtrl: TRadioButton;
    CheckBoxCtrl: TRadioButton;
    EditCtrl: TRadioButton;
    RadioGroup1: TRadioGroup;
    procedure ButtonCtrlClick(Sender: TObject);
    procedure CheckBoxCtrlClick(Sender: TObject);
    procedure DeleteCtrlClick(Sender: TObject);
    procedure EditCtrlClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    Counter: Integer;
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  CurrentCtrl: TControlClass;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ButtonCtrlClick(Sender: TObject);
begin
  CurrentCtrl := TButton;
end;

procedure TForm1.CheckBoxCtrlClick(Sender: TObject);
begin
  CurrentCtrl := TCheckBox;
end;

procedure TForm1.DeleteCtrlClick(Sender: TObject);
var i: Integer;
begin
  i := ListCtrls.ItemIndex;
  ListCtrls.Items.Objects[i].Destroy;
  ListCtrls.Items.Delete(i);
end;

procedure TForm1.EditCtrlClick(Sender: TObject);
begin
  CurrentCtrl := TEdit;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  NewCtrl: TControl;
  CtrlName: String;
begin
  NewCtrl := CurrentCtrl.Create(self);
  NewCtrl.Visible := False;
  NewCtrl.Parent := self;
  NewCtrl.Left := X;
  NewCtrl.Top := Y;
  Inc (Counter);
  CtrlName := CurrentCtrl.ClassName + IntToStr(Counter);
  Delete(CtrlName, 1, 1);
  NewCtrl.Name := CtrlName;
  NewCtrl.Visible := True;
  ListCtrls.AddItem(CtrlName, NewCtrl);
end;

end.

