program ref_lifespan;
uses SysUtils;
type
   TClass = class (TObject, IInterface)
      Name: String;
      frefcount : longint;
      constructor Create(aName: String);
      destructor Destroy; override;
      function QueryInterface(constref IID:TGUID; out Obj)
         :LongInt; CDecl;
      function _AddRef:LongInt; CDecl;
      function _Release:LongInt; CDecl;
   end;
   constructor TClass.Create (aName: String);
   begin
      WriteLn ('Creating ', aName);
      Name := aName;
   end;
   destructor TClass.Destroy;
   begin
      WriteLn ('Destroying ', Name);
   end;
   function TClass.QueryInterface
      (constref IID:TGUID; out Obj):LongInt; CDecl;
   begin
      if GetInterface(IID, Obj) then Result := 0
   end;
   function TClass._AddRef:LongInt; CDecl;
   begin
      _addref:=interlockedincrement(frefcount);
      WriteLn ('Reference ', Name, ' increase to ', frefcount);
   end;
   function TClass._Release:LongInt; CDecl;
   begin
      _Release:=interlockeddecrement(frefcount);
      WriteLn ('Reference ', Name, ' decrease to ', frefcount);
      if _Release=0 then self.destroy;
   end;
   
var
   GO: TClass;
   GI: IInterface;
   procedure LocalProc(Arg: IInterface);
   var
      LO: TClass;
      LI: IInterface;
   begin
      WriteLn ('Entered LocalProc');
      Write('LO := TClass.Create; '); LO := TClass.Create('Local A');
      Write('LI := LO; '); LI := LO;
      //raise Exception.Create('test exit');
      //Exit;
      //Halt;
      Write('LI := GO; '); LI := GO;
      Write('GI := TClass.Create; '); GI := TClass.Create('Local B');
      WriteLn ('Leaving LocalProc');
   end;
   
begin
   WriteLn ('Entered main program');
   Write('GO := TClass.Create; '); GO := TClass.Create('Global A');
   Write('GI := GO; '); GI := GO;
   LocalProc(TClass.Create ('Global B'));
   WriteLn ('Leaving main program');
end.
   