program singleton;
uses SysUtils, Classes;
type
   TBase = class
      class var b: Integer;
      class function VGetP: Integer; virtual;
      class procedure VSetP(const I: Integer); virtual;
      class function GetP: Integer;
      class procedure SetP(const I: Integer);
   end;
   TBaseClass = class of TBase;
   TDeriv = class sealed (TBase)
      class var d: Integer;
      class function VGetP: Integer; override;
      class procedure VSetP(const I: Integer); override;
   end;
   TDerivClass = class of TDeriv;
   
   class function TBase.VGetP: Integer;
   begin VGetP := b end;
   class procedure TBase.VSetP(const I: Integer);
   begin b := I end;
   class function TDeriv.VGetP: Integer;
   begin VGetP := d end;
   class procedure TDeriv.VSetP(const I: Integer);
   begin d := I end;
   
   class function TBase.GetP: Integer;
   begin GetP := b end;
   class procedure TBase.SetP(const I: Integer);
   begin b := I end;
var
   MyClass0, MyClass1, MyClass2: TBaseClass;
   MyClass3: TDerivClass;
begin
   MyClass0 := TBase;
   MyClass1 := TDeriv;
   MyClass2 := TDeriv;
   MyClass3 := TDeriv;
   MyClass3.VSetP(8);
   MyClass0.VSetP(3);
   MyClass2.VSetP(7);
   MyClass1.SetP(5);
   WriteLn ('MyClass0.VGetP=', MyClass0.VGetP,
            '; MyClass1.GetP=', MyClass1.GetP,
            '; MyClass2.VGetP=',MyClass2.VGetP,
            '; MyClass3.VGetP=', MyClass3.VGetP);
   WriteLn ('TBase.b=', TBase.b, '; TDeriv.d=',TDeriv.d);
end.
   